(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('react-dom')) :
  typeof define === 'function' && define.amd ? define(['react', 'react-dom'], factory) :
  (global = global || self, global.UiNavbar = factory(global.React, global.ReactDOM));
}(this, (function (React, ReactDOM) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;
  ReactDOM = ReactDOM && ReactDOM.hasOwnProperty('default') ? ReactDOM['default'] : ReactDOM;

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0

  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.

  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** */

  function __rest(s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
          t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
          for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
              if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                  t[p[i]] = s[p[i]];
          }
      return t;
  }

  var breakpoints = [
  	{
  		breakpoint: "xs",
  		abbr: "",
  		name: "Extra small",
  		"min-width": "0px",
  		container: ""
  	},
  	{
  		breakpoint: "sm",
  		abbr: "-sm",
  		name: "Small",
  		"min-width": "576px",
  		container: "540px"
  	},
  	{
  		breakpoint: "md",
  		abbr: "-md",
  		name: "Medium",
  		"min-width": "768px",
  		container: "720px"
  	},
  	{
  		breakpoint: "lg",
  		abbr: "-lg",
  		name: "Large",
  		"min-width": "992px",
  		container: "960px"
  	},
  	{
  		breakpoint: "xl",
  		abbr: "-xl",
  		name: "Extra large",
  		"min-width": "1200px",
  		container: "1140px"
  	}
  ];
  var colors = [
  	{
  		name: "blue",
  		hex: "#007bff"
  	},
  	{
  		name: "indigo",
  		hex: "#6610f2"
  	},
  	{
  		name: "purple",
  		hex: "#6f42c1"
  	},
  	{
  		name: "pink",
  		hex: "#e83e8c"
  	},
  	{
  		name: "red",
  		hex: "#dc3545"
  	},
  	{
  		name: "orange",
  		hex: "#fd7e14"
  	},
  	{
  		name: "yellow",
  		hex: "#ffc107"
  	},
  	{
  		name: "green",
  		hex: "#28a745"
  	},
  	{
  		name: "teal",
  		hex: "#20c997"
  	},
  	{
  		name: "cyan",
  		hex: "#17a2b8"
  	},
  	{
  		name: "white",
  		hex: "#fff"
  	},
  	{
  		name: "gray",
  		hex: "#868e96"
  	},
  	{
  		name: "gray-dark",
  		hex: "#343a40"
  	}
  ];
  var json = {
  	breakpoints: breakpoints,
  	colors: colors,
  	"theme-colors": [
  	{
  		name: "primary",
  		hex: "#007bff"
  	},
  	{
  		name: "secondary",
  		hex: "#868e96"
  	},
  	{
  		name: "success",
  		hex: "#28a745"
  	},
  	{
  		name: "danger",
  		hex: "#dc3545"
  	},
  	{
  		name: "warning",
  		hex: "#ffc107"
  	},
  	{
  		name: "info",
  		hex: "#17a2b8"
  	},
  	{
  		name: "light",
  		hex: "#f8f9fa"
  	},
  	{
  		name: "dark",
  		hex: "#343a40"
  	}
  ]
  };

  function arraify(value) {
    return Array.isArray(value) ? value : [value];
  }
  function dedupe(list) {
    if (!Array.isArray(list)) throw new Error("muse be list!");
    return Array.from(new Set(list));
  }
  function flatten(listOrItem) {
    var newList = [];

    if (Array.isArray(listOrItem)) {
      listOrItem.forEach(function (item) {
        newList = newList.concat(flatten(item));
      });
    } else newList.push(listOrItem);

    return newList;
  }

  function rclassnames(props) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var clsList = dedupe(flatten(args).concat([props.className, props["class"]]).filter(function (x) {
      return x && typeof x === 'string';
    }).map(function (x) {
      return x && x.trim();
    }).join(' ').split(' '));
    if (!clsList.length) return;
    return clsList.join(' ');
  }
  function tryUseContext(ContextRef) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$fallbackValue = _ref.fallbackValue,
        fallbackValue = _ref$fallbackValue === void 0 ? {} : _ref$fallbackValue;

    var ctxValue = fallbackValue;

    try {
      ctxValue = React__default.useContext(ContextRef);
    } catch (error) {}

    return ctxValue;
  }
  function renderJSXFunc(children) {
    var renderContext = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (typeof children === 'function') return children.call(null, renderContext);
    return children;
  }

  var themes = json['theme-colors'].map(function (theme) {
    return theme.name;
  });
  var sizes = json['breakpoints'].map(function (x) {
    return x.breakpoint;
  }).filter(function (x) {
    return x;
  });
  function filterThemeName() {
    var theme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    if (themes.includes(theme)) return theme;
  }
  function filterRepsonsiveSize() {
    var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    if (sizes.includes(size)) return size;
  }
  function resolveJSXElement(inputJSXElement) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$default = _ref["default"],
        defaultValue = _ref$default === void 0 ? React__default.Fragment : _ref$default,
        _ref$allowedHTMLTags = _ref.allowedHTMLTags,
        allowedHTMLTags = _ref$allowedHTMLTags === void 0 ? undefined : _ref$allowedHTMLTags;

    if (!inputJSXElement) return defaultValue;

    if (allowedHTMLTags && typeof inputJSXElement === 'string') {
      inputJSXElement = inputJSXElement.toString();
      allowedHTMLTags = arraify(allowedHTMLTags).filter(function (x) {
        return typeof x === 'string';
      }).map(function (x) {
        return x.toString();
      });
      if (allowedHTMLTags.length && !allowedHTMLTags.includes(inputJSXElement)) throw new Error("[resolveJSXElement] inputJSXElement must be valid string: ".concat(allowedHTMLTags.join(', '), "; but ").concat(inputJSXElement, " given!"));
    }

    return inputJSXElement;
  }

  function _extends$1() {
    _extends$1 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends$1.apply(this, arguments);
  }
  function __rest$1(s, e) {
    var t = {};
    for (var p in s) {
      if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }
    if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
    }
    return t;
  }
  var Anchor = React__default.forwardRef(function (_a,
  ref) {
    var children = _a.children,
        _b = _a.href,
        href = _b === void 0 ? 'javascript:;' : _b,
        props = __rest$1(_a, ["children", "href"]);
    return React__default.createElement("a", _extends$1({}, props, {
      ref: ref
    }, href && {
      href: href
    }), children);
  });

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';
  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  function emptyFunction() {}
  function emptyFunctionWithReset() {}
  emptyFunctionWithReset.resetWarningCache = emptyFunction;
  var factoryWithThrowingShims = function () {
    function shim(props, propName, componentName, location, propFullName, secret) {
      if (secret === ReactPropTypesSecret_1) {
        return;
      }
      var err = new Error('Calling PropTypes validators directly is not supported by the `prop-types` package. ' + 'Use PropTypes.checkPropTypes() to call them. ' + 'Read more at http://fb.me/use-check-prop-types');
      err.name = 'Invariant Violation';
      throw err;
    }
    shim.isRequired = shim;
    function getShim() {
      return shim;
    }
    var ReactPropTypes = {
      array: shim,
      bool: shim,
      func: shim,
      number: shim,
      object: shim,
      string: shim,
      symbol: shim,
      any: shim,
      arrayOf: getShim,
      element: shim,
      elementType: shim,
      instanceOf: getShim,
      node: shim,
      objectOf: getShim,
      oneOf: getShim,
      oneOfType: getShim,
      shape: getShim,
      exact: getShim,
      checkPropTypes: emptyFunctionWithReset,
      resetWarningCache: emptyFunction
    };
    ReactPropTypes.PropTypes = ReactPropTypes;
    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
  {
    module.exports = factoryWithThrowingShims();
  }
  });
  var propTypes_1 = propTypes.array;
  var propTypes_2 = propTypes.bool;
  var propTypes_3 = propTypes.func;
  var propTypes_4 = propTypes.number;
  var propTypes_5 = propTypes.object;
  var propTypes_6 = propTypes.string;
  var propTypes_7 = propTypes.symbol;
  var propTypes_8 = propTypes.any;
  var propTypes_9 = propTypes.arrayOf;
  var propTypes_10 = propTypes.element;
  var propTypes_11 = propTypes.elementType;
  var propTypes_12 = propTypes.instanceOf;
  var propTypes_13 = propTypes.node;
  var propTypes_14 = propTypes.objectOf;
  var propTypes_15 = propTypes.oneOf;
  var propTypes_16 = propTypes.oneOfType;
  var propTypes_17 = propTypes.shape;
  var propTypes_18 = propTypes.exact;
  var propTypes_19 = propTypes.checkPropTypes;
  var propTypes_20 = propTypes.resetWarningCache;
  var propTypes_21 = propTypes.PropTypes;

  var config = {
    disabled: false
  };

  var TransitionGroupContext = React__default.createContext(null);

  var UNMOUNTED = 'unmounted';
  var EXITED = 'exited';
  var ENTERING = 'entering';
  var ENTERED = 'entered';
  var EXITING = 'exiting';
  var Transition = function (_React$Component) {
    _inheritsLoose(Transition, _React$Component);
    function Transition(props, context) {
      var _this;
      _this = _React$Component.call(this, props, context) || this;
      var parentGroup = context;
      var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
      var initialStatus;
      _this.appearStatus = null;
      if (props["in"]) {
        if (appear) {
          initialStatus = EXITED;
          _this.appearStatus = ENTERING;
        } else {
          initialStatus = ENTERED;
        }
      } else {
        if (props.unmountOnExit || props.mountOnEnter) {
          initialStatus = UNMOUNTED;
        } else {
          initialStatus = EXITED;
        }
      }
      _this.state = {
        status: initialStatus
      };
      _this.nextCallback = null;
      return _this;
    }
    Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
      var nextIn = _ref["in"];
      if (nextIn && prevState.status === UNMOUNTED) {
        return {
          status: EXITED
        };
      }
      return null;
    };
    var _proto = Transition.prototype;
    _proto.componentDidMount = function componentDidMount() {
      this.updateStatus(true, this.appearStatus);
    };
    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
      var nextStatus = null;
      if (prevProps !== this.props) {
        var status = this.state.status;
        if (this.props["in"]) {
          if (status !== ENTERING && status !== ENTERED) {
            nextStatus = ENTERING;
          }
        } else {
          if (status === ENTERING || status === ENTERED) {
            nextStatus = EXITING;
          }
        }
      }
      this.updateStatus(false, nextStatus);
    };
    _proto.componentWillUnmount = function componentWillUnmount() {
      this.cancelNextCallback();
    };
    _proto.getTimeouts = function getTimeouts() {
      var timeout = this.props.timeout;
      var exit, enter, appear;
      exit = enter = appear = timeout;
      if (timeout != null && typeof timeout !== 'number') {
        exit = timeout.exit;
        enter = timeout.enter;
        appear = timeout.appear !== undefined ? timeout.appear : enter;
      }
      return {
        exit: exit,
        enter: enter,
        appear: appear
      };
    };
    _proto.updateStatus = function updateStatus(mounting, nextStatus) {
      if (mounting === void 0) {
        mounting = false;
      }
      if (nextStatus !== null) {
        this.cancelNextCallback();
        var node = ReactDOM.findDOMNode(this);
        if (nextStatus === ENTERING) {
          this.performEnter(node, mounting);
        } else {
          this.performExit(node);
        }
      } else if (this.props.unmountOnExit && this.state.status === EXITED) {
        this.setState({
          status: UNMOUNTED
        });
      }
    };
    _proto.performEnter = function performEnter(node, mounting) {
      var _this2 = this;
      var enter = this.props.enter;
      var appearing = this.context ? this.context.isMounting : mounting;
      var timeouts = this.getTimeouts();
      var enterTimeout = appearing ? timeouts.appear : timeouts.enter;
      if (!mounting && !enter || config.disabled) {
        this.safeSetState({
          status: ENTERED
        }, function () {
          _this2.props.onEntered(node);
        });
        return;
      }
      this.props.onEnter(node, appearing);
      this.safeSetState({
        status: ENTERING
      }, function () {
        _this2.props.onEntering(node, appearing);
        _this2.onTransitionEnd(node, enterTimeout, function () {
          _this2.safeSetState({
            status: ENTERED
          }, function () {
            _this2.props.onEntered(node, appearing);
          });
        });
      });
    };
    _proto.performExit = function performExit(node) {
      var _this3 = this;
      var exit = this.props.exit;
      var timeouts = this.getTimeouts();
      if (!exit || config.disabled) {
        this.safeSetState({
          status: EXITED
        }, function () {
          _this3.props.onExited(node);
        });
        return;
      }
      this.props.onExit(node);
      this.safeSetState({
        status: EXITING
      }, function () {
        _this3.props.onExiting(node);
        _this3.onTransitionEnd(node, timeouts.exit, function () {
          _this3.safeSetState({
            status: EXITED
          }, function () {
            _this3.props.onExited(node);
          });
        });
      });
    };
    _proto.cancelNextCallback = function cancelNextCallback() {
      if (this.nextCallback !== null) {
        this.nextCallback.cancel();
        this.nextCallback = null;
      }
    };
    _proto.safeSetState = function safeSetState(nextState, callback) {
      callback = this.setNextCallback(callback);
      this.setState(nextState, callback);
    };
    _proto.setNextCallback = function setNextCallback(callback) {
      var _this4 = this;
      var active = true;
      this.nextCallback = function (event) {
        if (active) {
          active = false;
          _this4.nextCallback = null;
          callback(event);
        }
      };
      this.nextCallback.cancel = function () {
        active = false;
      };
      return this.nextCallback;
    };
    _proto.onTransitionEnd = function onTransitionEnd(node, timeout, handler) {
      this.setNextCallback(handler);
      var doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;
      if (!node || doesNotHaveTimeoutOrListener) {
        setTimeout(this.nextCallback, 0);
        return;
      }
      if (this.props.addEndListener) {
        this.props.addEndListener(node, this.nextCallback);
      }
      if (timeout != null) {
        setTimeout(this.nextCallback, timeout);
      }
    };
    _proto.render = function render() {
      var status = this.state.status;
      if (status === UNMOUNTED) {
        return null;
      }
      var _this$props = this.props,
          children = _this$props.children,
          childProps = _objectWithoutPropertiesLoose(_this$props, ["children"]);
      delete childProps["in"];
      delete childProps.mountOnEnter;
      delete childProps.unmountOnExit;
      delete childProps.appear;
      delete childProps.enter;
      delete childProps.exit;
      delete childProps.timeout;
      delete childProps.addEndListener;
      delete childProps.onEnter;
      delete childProps.onEntering;
      delete childProps.onEntered;
      delete childProps.onExit;
      delete childProps.onExiting;
      delete childProps.onExited;
      if (typeof children === 'function') {
        return React__default.createElement(TransitionGroupContext.Provider, {
          value: null
        }, children(status, childProps));
      }
      var child = React__default.Children.only(children);
      return (
        React__default.createElement(TransitionGroupContext.Provider, {
          value: null
        }, React__default.cloneElement(child, childProps))
      );
    };
    return Transition;
  }(React__default.Component);
  Transition.contextType = TransitionGroupContext;
  Transition.propTypes =  {};
  function noop() {}
  Transition.defaultProps = {
    "in": false,
    mountOnEnter: false,
    unmountOnExit: false,
    appear: false,
    enter: true,
    exit: true,
    onEnter: noop,
    onEntering: noop,
    onEntered: noop,
    onExit: noop,
    onExiting: noop,
    onExited: noop
  };
  Transition.UNMOUNTED = 0;
  Transition.EXITED = 1;
  Transition.ENTERING = 2;
  Transition.ENTERED = 3;
  Transition.EXITING = 4;

  var breakpoints$1 = [{
    breakpoint: "xs",
    abbr: "",
    name: "Extra small",
    "min-width": "0px",
    container: ""
  }, {
    breakpoint: "sm",
    abbr: "-sm",
    name: "Small",
    "min-width": "576px",
    container: "540px"
  }, {
    breakpoint: "md",
    abbr: "-md",
    name: "Medium",
    "min-width": "768px",
    container: "720px"
  }, {
    breakpoint: "lg",
    abbr: "-lg",
    name: "Large",
    "min-width": "992px",
    container: "960px"
  }, {
    breakpoint: "xl",
    abbr: "-xl",
    name: "Extra large",
    "min-width": "1200px",
    container: "1140px"
  }];
  var colors$1 = [{
    name: "blue",
    hex: "#007bff"
  }, {
    name: "indigo",
    hex: "#6610f2"
  }, {
    name: "purple",
    hex: "#6f42c1"
  }, {
    name: "pink",
    hex: "#e83e8c"
  }, {
    name: "red",
    hex: "#dc3545"
  }, {
    name: "orange",
    hex: "#fd7e14"
  }, {
    name: "yellow",
    hex: "#ffc107"
  }, {
    name: "green",
    hex: "#28a745"
  }, {
    name: "teal",
    hex: "#20c997"
  }, {
    name: "cyan",
    hex: "#17a2b8"
  }, {
    name: "white",
    hex: "#fff"
  }, {
    name: "gray",
    hex: "#868e96"
  }, {
    name: "gray-dark",
    hex: "#343a40"
  }];
  var json$1 = {
    breakpoints: breakpoints$1,
    colors: colors$1,
    "theme-colors": [{
      name: "primary",
      hex: "#007bff"
    }, {
      name: "secondary",
      hex: "#868e96"
    }, {
      name: "success",
      hex: "#28a745"
    }, {
      name: "danger",
      hex: "#dc3545"
    }, {
      name: "warning",
      hex: "#ffc107"
    }, {
      name: "info",
      hex: "#17a2b8"
    }, {
      name: "light",
      hex: "#f8f9fa"
    }, {
      name: "dark",
      hex: "#343a40"
    }]
  };
  function arraify$1(value) {
    return Array.isArray(value) ? value : [value];
  }
  function dedupe$1(list) {
    if (!Array.isArray(list)) throw new Error("muse be list!");
    return Array.from(new Set(list));
  }
  function flatten$1(listOrItem) {
    var newList = [];
    if (Array.isArray(listOrItem)) {
      listOrItem.forEach(function (item) {
        newList = newList.concat(flatten$1(item));
      });
    } else newList.push(listOrItem);
    return newList;
  }
  function rclassnames$1(props) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    var clsList = dedupe$1(flatten$1(args).concat([props.className, props["class"]]).filter(function (x) {
      return x && typeof x === 'string';
    }).map(function (x) {
      return x && x.trim();
    }).join(' ').split(' '));
    if (!clsList.length) return;
    return clsList.join(' ');
  }
  function noop$4() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
  }
  function useDefaultValue(defaultValue, calback) {
    if (calback === void 0) {
      calback = noop$4;
    }
    var firstValRef = React__default.useRef(defaultValue);
    React__default.useEffect(function () {
      calback(firstValRef.current);
    }, [firstValRef.current]);
  }
  var themes$1 = json$1['theme-colors'].map(function (theme) {
    return theme.name;
  });
  var sizes$1 = json$1['breakpoints'].map(function (x) {
    return x.breakpoint;
  }).filter(function (x) {
    return x;
  });
  var TransitionTimeouts = {
    Fade: 150,
    Collapse: 350,
    Modal: 300,
    Carousel: 600
  };
  function resolveJSXElement$1(inputJSXElement, _a) {
    var _b = _a === void 0 ? {} : _a,
        _c = _b["default"],
        defaultValue = _c === void 0 ? React__default.Fragment : _c,
        _d = _b.allowedHTMLTags,
        allowedHTMLTags = _d === void 0 ? undefined : _d;
    if (!inputJSXElement) return defaultValue;
    if (allowedHTMLTags && typeof inputJSXElement === 'string') {
      inputJSXElement = inputJSXElement.toString();
      allowedHTMLTags = arraify$1(allowedHTMLTags).filter(function (x) {
        return typeof x === 'string';
      }).map(function (x) {
        return x.toString();
      });
      if (allowedHTMLTags.length && !allowedHTMLTags.includes(inputJSXElement)) throw new Error("[resolveJSXElement] inputJSXElement must be valid string: " + allowedHTMLTags.join(', ') + "; but " + inputJSXElement + " given!");
    }
    return inputJSXElement;
  }

  function _extends$2() {
    _extends$2 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends$2.apply(this, arguments);
  }
  var _assign = function __assign() {
    _assign = Object.assign || function __assign(t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) {
          if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
      }
      return t;
    };
    return _assign.apply(this, arguments);
  };
  function __rest$2(s, e) {
    var t = {};
    for (var p in s) {
      if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }
    if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
    }
    return t;
  }
  var _a;
  function getTransitionClass(status) {
    return transtionClasses[status] || 'collapse';
  }
  function getNodeHeight(node) {
    return node.scrollHeight;
  }
  function noop$1() {}
  var transtionClasses = (_a = {}, _a["entering"] = 'collapsing', _a["entered"] = 'collapse show', _a["exiting"] = 'collapsing', _a["exited"] = 'collapse', _a["unmounted"] = '', _a);
  function CollapseProto(_a, ref) {
    var children = _a.children,
        _b = _a.as,
        _as = _b === void 0 ? 'div' : _b,
        _c = _a.collapse,
        propCollapsed = _c === void 0 ? true : _c,
        _d = _a.onEntering,
        onEntering = _d === void 0 ? noop$1 : _d,
        _e = _a.onEntered,
        onEntered = _e === void 0 ? noop$1 : _e,
        _f = _a.onExit,
        onExit = _f === void 0 ? noop$1 : _f,
        _g = _a.onExiting,
        onExiting = _g === void 0 ? noop$1 : _g,
        _h = _a.onExited,
        onExited = _h === void 0 ? noop$1 : _h,
        props = __rest$2(_a, ["children", "as", "collapse", "onEntering", "onEntered", "onExit", "onExiting", "onExited"]);
    var JSXEl = resolveJSXElement$1(_as, {
    });
    var _j = React__default.useState(true),
        collapse = _j[0],
        setCollapse = _j[1];
    useDefaultValue(propCollapsed, function (defaultValue) {
      if (defaultValue !== collapse) setCollapse(defaultValue);
    });
    React__default.useEffect(function () {
      setCollapse(propCollapsed);
    }, [propCollapsed]);
    var _k = React__default.useState(null),
        height = _k[0],
        setHeight = _k[1];
    var hRef = React__default.useRef(height);
    var _onEntering = function _onEntering(node, isAppearing) {
      setHeight(getNodeHeight(node));
      onEntering(node, isAppearing);
    };
    var _onEntered = function _onEntered(node, isAppearing) {
      setHeight(null);
      hRef.current = height;
      onEntered(node, isAppearing);
    };
    var _onExit = function _onExit(node) {
      setHeight(getNodeHeight(node));
      onExit(node);
    };
    var _onExiting = function _onExiting(node) {
      hRef.current = null;
      setHeight(0);
      onExiting(node);
    };
    var _onExited = function _onExited(node) {
      setHeight(null);
      onExited(node);
    };
    ref = ref || React__default.useRef(null);
    return React__default.createElement(React__default.Fragment, null, React__default.createElement(Transition, _extends$2({}, Transition.defaultProps, {
      appear: false,
      enter: true,
      exit: true,
      timeout: {
        enter: TransitionTimeouts.Collapse,
        exit: TransitionTimeouts.Collapse
      },
      "in": !collapse,
      onEntering: _onEntering,
      onEntered: _onEntered,
      onExit: _onExit,
      onExiting: _onExiting,
      onExited: _onExited
    }), function (state) {
      return React__default.createElement(JSXEl, _extends$2({}, props, ref && {
        ref: ref
      }, {
        className: rclassnames$1(props, [getTransitionClass(state)]),
        style: _assign(_assign(_assign({}, props.style), height !== null && {
          height: height
        }), hRef.current !== null && {
          height: hRef.current
        })
      }), children);
    }));
  }

  var ControlledCollapse = React__default.forwardRef(CollapseProto);
  var NavbarContext = React__default.createContext({});
  var ctxSymbol = Symbol('#Navbar');
  var useHookSymbols = {
    collapse: Symbol('#Navbar#useHook#collapse')
  };

  var useInitContextState = function useInitContextState(SYMBOL) {
    if (SYMBOL === void 0) {
      SYMBOL = ctxSymbol;
    }

    var _a = React__default.useState(true),
        collapse = _a[0],
        setCollapse = _a[1];

    var context = {
      symbol: SYMBOL,
      collapse: collapse,
      refs: {},
      _toggleCollapse: function _toggleCollapse(nextStatus) {
        if (nextStatus === void 0) {
          nextStatus = !context.collapse;
        }

        return setCollapse(nextStatus);
      },
      _registerRef: function _registerRef(member, ref) {
        switch (member) {
          case 'toggle':
          case 'collapse':
            if (context.refs[member]) throw new Error("[Navbar] member ref has been existed, stop add member under this context!");
            context.refs[member] = ref;
            break;

          default:
            throw new Error("[Navbar] unknown member ref '" + member + "', report to your administrator.");
        }
      },
      _unregisterRef: function _unregisterRef(member) {
        if (context.refs[member]) context.refs[member] = null;
      }
    }; // repass change of `collapse` state to last context

    var lastCtxState = tryUseContext(NavbarContext);
    React__default.useEffect(function () {
      if (lastCtxState.symbol === useHookSymbols.collapse) {
        lastCtxState._toggleCollapse(context.collapse);
      }
    }, [context.collapse]);
    return [context];
  };

  var useRefRegistry = function useRefRegistry(memberType, ref) {
    var navbarCtx = tryUseContext(NavbarContext);
    React__default.useEffect(function () {
      if (navbarCtx.symbol !== ctxSymbol) return;

      navbarCtx._registerRef(memberType, ref);

      return function () {
        navbarCtx._unregisterRef(memberType);
      };
    }, []);
    return [navbarCtx, ref];
  };

  var NavbarProto = React__default.forwardRef(function (_a, ref) {
    var children = _a.children,
        _b = _a.as,
        _as = _b === void 0 ? 'nav' : _b,
        expandWhen = _a.expandWhen,
        theme = _a.theme,
        bgTheme = _a.bgTheme,
        props = __rest(_a, ["children", "as", "expandWhen", "theme", "bgTheme"]);

    var JSXEl = resolveJSXElement(_as, {
      allowedHTMLTags: ['div', 'nav', 'header']
    });
    expandWhen = filterRepsonsiveSize(expandWhen);
    theme = filterThemeName(theme);
    bgTheme = filterThemeName(bgTheme);
    var contextState = useInitContextState(ctxSymbol)[0];
    return React__default.createElement(NavbarContext.Provider, {
      value: contextState
    }, React__default.createElement(JSXEl, _extends({}, props, {
      ref: ref,
      className: rclassnames(props, ["navbar", expandWhen && "navbar-expand-" + expandWhen, theme && "navbar-" + theme, bgTheme && "bg-" + bgTheme])
    }), children));
  });
  /**
   * @see https://getbootstrap.com/docs/4.4/components/navbar/#supported-content
   *
   * @inner-content `.navbar-brand`
   * @inner-content `.navbar-nav`
   * @inner-content `.navbar-toggler`
   *
   * @inner-content `.navbar-text`
   * @inner-content `.collapse.navbar-collapse`
   */

  var Navbar = function Navbar(props) {
    return React__default.createElement(NavbarProto, props);
  };

  Navbar.Brand = function (_a) {
    var children = _a.children,
        _b = _a.as,
        _as = _b === void 0 ? 'a' : _b,
        props = __rest(_a, ["children", "as"]);

    if (_as === 'a') _as = Anchor;
    var JSXEl = resolveJSXElement(_as, {
      /* allowedHTMLTags: [] */
    });
    return React__default.createElement(JSXEl, _extends({}, props, {
      className: rclassnames(props, ['navbar-brand'])
    }), children);
  };

  Navbar.Text = function (_a) {
    var children = _a.children,
        _b = _a.as,
        _as = _b === void 0 ? 'span' : _b,
        props = __rest(_a, ["children", "as"]);

    if (_as === 'a') _as = Anchor;
    var JSXEl = resolveJSXElement(_as, {
      /* allowedHTMLTags: [] */
    });
    return React__default.createElement(JSXEl, _extends({}, props, {
      className: rclassnames(props, ['navbar-text'])
    }), children);
  };

  Navbar.Toggle = React__default.forwardRef(function (_a, ref) {
    var // children = (<span className="navbar-toggler-icon" />),
    _b = _a.as,
        // children = (<span className="navbar-toggler-icon" />),
    _as = _b === void 0 ? 'button' : _b,
        _c = _a.target,
        target = _c === void 0 ? '' : _c,
        props = __rest(_a, ["as", "target"]);

    var JSXEl = resolveJSXElement(_as, {
      /* allowedHTMLTags: [] */
    });
    ref = ref || React__default.useRef(null);
    var navbarCtx = useRefRegistry('toggle', ref)[0];
    return React__default.createElement(JSXEl, _extends({}, props, {
      ref: ref,
      className: rclassnames(props, ['navbar-toggler']),
      type: "button",
      "data-toggle": "collapse"
    }, target && {
      'data-target': "#" + target,
      'aria-controls': "" + target
    }, {
      "aria-expanded": !navbarCtx.collapse,
      "aria-label": "Toggle navigation",
      onClick: function onClick(evt) {
        if (navbarCtx.symbol === ctxSymbol) navbarCtx._toggleCollapse(!navbarCtx.collapse);
        if (typeof props.onClick === 'function') props.onClick(evt);
      }
    }), React__default.createElement("span", {
      className: "navbar-toggler-icon"
    }));
  });
  Navbar.Collapse = React__default.forwardRef(function (_a, ref) {
    var children = _a.children,
        props = __rest(_a, ["children"]);

    ref = ref || React__default.useRef(null);
    var navbarCtx = useRefRegistry('collapse', ref)[0];
    return React__default.createElement(ControlledCollapse, _extends({}, props, {
      ref: ref,
      collapse: navbarCtx.collapse,
      className: rclassnames(props, ['navbar-collapse'])
    }), children);
  });

  Navbar.useCollapse = function (fnOrComponent) {
    var contextState = useInitContextState(useHookSymbols.collapse)[0];
    contextState.symbol = useHookSymbols.collapse;
    return React__default.createElement(NavbarContext.Provider, {
      value: contextState
    }, renderJSXFunc(fnOrComponent, {
      collapse: contextState.collapse
    }));
  };

  function styleInject(css, ref) {
    if (ref === void 0) ref = {};
    var insertAt = ref.insertAt;
    if (!css || typeof document === 'undefined') {
      return;
    }
    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';
    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }
    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css = ".navbar{position:relative;padding:.5rem 1rem}.navbar,.navbar .container,.navbar .container-fluid,.navbar>.container-lg,.navbar>.container-md,.navbar>.container-sm,.navbar>.container-xl{display:flex;flex-wrap:wrap;align-items:center;justify-content:space-between}.navbar-brand{display:inline-block;padding-top:.3125rem;padding-bottom:.3125rem;margin-right:1rem;font-size:1.25rem;line-height:inherit;white-space:nowrap}.navbar-brand:focus,.navbar-brand:hover{text-decoration:none}.navbar-nav{display:flex;flex-direction:column;padding-left:0;margin-bottom:0;list-style:none}.navbar-nav .nav-link{padding-right:0;padding-left:0}.navbar-nav .dropdown-menu{position:static;float:none}.navbar-text{display:inline-block;padding-top:.5rem;padding-bottom:.5rem}.navbar-collapse{flex-basis:100%;flex-grow:1;align-items:center}.navbar-toggler{padding:.25rem .75rem;font-size:1.25rem;line-height:1;background-color:transparent;border:1px solid transparent;border-radius:.25rem}.navbar-toggler:focus,.navbar-toggler:hover{text-decoration:none}.navbar-toggler-icon{display:inline-block;width:1.5em;height:1.5em;vertical-align:middle;content:\"\";background:no-repeat 50%;background-size:100% 100%}@media (max-width:575.98px){.navbar-expand-sm>.container,.navbar-expand-sm>.container-fluid,.navbar-expand-sm>.container-lg,.navbar-expand-sm>.container-md,.navbar-expand-sm>.container-sm,.navbar-expand-sm>.container-xl{padding-right:0;padding-left:0}}@media (min-width:576px){.navbar-expand-sm{flex-flow:row nowrap;justify-content:flex-start}.navbar-expand-sm .navbar-nav{flex-direction:row}.navbar-expand-sm .navbar-nav .dropdown-menu{position:absolute}.navbar-expand-sm .navbar-nav .nav-link{padding-right:.5rem;padding-left:.5rem}.navbar-expand-sm>.container,.navbar-expand-sm>.container-fluid,.navbar-expand-sm>.container-lg,.navbar-expand-sm>.container-md,.navbar-expand-sm>.container-sm,.navbar-expand-sm>.container-xl{flex-wrap:nowrap}.navbar-expand-sm .navbar-collapse{display:flex!important;flex-basis:auto}.navbar-expand-sm .navbar-toggler{display:none}}@media (max-width:767.98px){.navbar-expand-md>.container,.navbar-expand-md>.container-fluid,.navbar-expand-md>.container-lg,.navbar-expand-md>.container-md,.navbar-expand-md>.container-sm,.navbar-expand-md>.container-xl{padding-right:0;padding-left:0}}@media (min-width:768px){.navbar-expand-md{flex-flow:row nowrap;justify-content:flex-start}.navbar-expand-md .navbar-nav{flex-direction:row}.navbar-expand-md .navbar-nav .dropdown-menu{position:absolute}.navbar-expand-md .navbar-nav .nav-link{padding-right:.5rem;padding-left:.5rem}.navbar-expand-md>.container,.navbar-expand-md>.container-fluid,.navbar-expand-md>.container-lg,.navbar-expand-md>.container-md,.navbar-expand-md>.container-sm,.navbar-expand-md>.container-xl{flex-wrap:nowrap}.navbar-expand-md .navbar-collapse{display:flex!important;flex-basis:auto}.navbar-expand-md .navbar-toggler{display:none}}@media (max-width:991.98px){.navbar-expand-lg>.container,.navbar-expand-lg>.container-fluid,.navbar-expand-lg>.container-lg,.navbar-expand-lg>.container-md,.navbar-expand-lg>.container-sm,.navbar-expand-lg>.container-xl{padding-right:0;padding-left:0}}@media (min-width:992px){.navbar-expand-lg{flex-flow:row nowrap;justify-content:flex-start}.navbar-expand-lg .navbar-nav{flex-direction:row}.navbar-expand-lg .navbar-nav .dropdown-menu{position:absolute}.navbar-expand-lg .navbar-nav .nav-link{padding-right:.5rem;padding-left:.5rem}.navbar-expand-lg>.container,.navbar-expand-lg>.container-fluid,.navbar-expand-lg>.container-lg,.navbar-expand-lg>.container-md,.navbar-expand-lg>.container-sm,.navbar-expand-lg>.container-xl{flex-wrap:nowrap}.navbar-expand-lg .navbar-collapse{display:flex!important;flex-basis:auto}.navbar-expand-lg .navbar-toggler{display:none}}@media (max-width:1199.98px){.navbar-expand-xl>.container,.navbar-expand-xl>.container-fluid,.navbar-expand-xl>.container-lg,.navbar-expand-xl>.container-md,.navbar-expand-xl>.container-sm,.navbar-expand-xl>.container-xl{padding-right:0;padding-left:0}}@media (min-width:1200px){.navbar-expand-xl{flex-flow:row nowrap;justify-content:flex-start}.navbar-expand-xl .navbar-nav{flex-direction:row}.navbar-expand-xl .navbar-nav .dropdown-menu{position:absolute}.navbar-expand-xl .navbar-nav .nav-link{padding-right:.5rem;padding-left:.5rem}.navbar-expand-xl>.container,.navbar-expand-xl>.container-fluid,.navbar-expand-xl>.container-lg,.navbar-expand-xl>.container-md,.navbar-expand-xl>.container-sm,.navbar-expand-xl>.container-xl{flex-wrap:nowrap}.navbar-expand-xl .navbar-collapse{display:flex!important;flex-basis:auto}.navbar-expand-xl .navbar-toggler{display:none}}.navbar-expand{flex-flow:row nowrap;justify-content:flex-start}.navbar-expand>.container,.navbar-expand>.container-fluid,.navbar-expand>.container-lg,.navbar-expand>.container-md,.navbar-expand>.container-sm,.navbar-expand>.container-xl{padding-right:0;padding-left:0}.navbar-expand .navbar-nav{flex-direction:row}.navbar-expand .navbar-nav .dropdown-menu{position:absolute}.navbar-expand .navbar-nav .nav-link{padding-right:.5rem;padding-left:.5rem}.navbar-expand>.container,.navbar-expand>.container-fluid,.navbar-expand>.container-lg,.navbar-expand>.container-md,.navbar-expand>.container-sm,.navbar-expand>.container-xl{flex-wrap:nowrap}.navbar-expand .navbar-collapse{display:flex!important;flex-basis:auto}.navbar-expand .navbar-toggler{display:none}.navbar-light .navbar-brand,.navbar-light .navbar-brand:focus,.navbar-light .navbar-brand:hover{color:rgba(0,0,0,.9)}.navbar-light .navbar-nav .nav-link{color:rgba(0,0,0,.5)}.navbar-light .navbar-nav .nav-link:focus,.navbar-light .navbar-nav .nav-link:hover{color:rgba(0,0,0,.7)}.navbar-light .navbar-nav .nav-link.disabled{color:rgba(0,0,0,.3)}.navbar-light .navbar-nav .active>.nav-link,.navbar-light .navbar-nav .nav-link.active,.navbar-light .navbar-nav .nav-link.show,.navbar-light .navbar-nav .show>.nav-link{color:rgba(0,0,0,.9)}.navbar-light .navbar-toggler{color:rgba(0,0,0,.5);border-color:rgba(0,0,0,.1)}.navbar-light .navbar-toggler-icon{background-image:url(\"data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='30' height='30'%3E%3Cpath stroke='rgba(0, 0, 0, 0.5)' stroke-linecap='round' stroke-miterlimit='10' stroke-width='2' d='M4 7h22M4 15h22M4 23h22'/%3E%3C/svg%3E\")}.navbar-light .navbar-text{color:rgba(0,0,0,.5)}.navbar-light .navbar-text a,.navbar-light .navbar-text a:focus,.navbar-light .navbar-text a:hover{color:rgba(0,0,0,.9)}.navbar-dark .navbar-brand,.navbar-dark .navbar-brand:focus,.navbar-dark .navbar-brand:hover{color:#fff}.navbar-dark .navbar-nav .nav-link{color:hsla(0,0%,100%,.5)}.navbar-dark .navbar-nav .nav-link:focus,.navbar-dark .navbar-nav .nav-link:hover{color:hsla(0,0%,100%,.75)}.navbar-dark .navbar-nav .nav-link.disabled{color:hsla(0,0%,100%,.25)}.navbar-dark .navbar-nav .active>.nav-link,.navbar-dark .navbar-nav .nav-link.active,.navbar-dark .navbar-nav .nav-link.show,.navbar-dark .navbar-nav .show>.nav-link{color:#fff}.navbar-dark .navbar-toggler{color:hsla(0,0%,100%,.5);border-color:hsla(0,0%,100%,.1)}.navbar-dark .navbar-toggler-icon{background-image:url(\"data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='30' height='30'%3E%3Cpath stroke='rgba(255, 255, 255, 0.5)' stroke-linecap='round' stroke-miterlimit='10' stroke-width='2' d='M4 7h22M4 15h22M4 23h22'/%3E%3C/svg%3E\")}.navbar-dark .navbar-text{color:hsla(0,0%,100%,.5)}.navbar-dark .navbar-text a,.navbar-dark .navbar-text a:focus,.navbar-dark .navbar-text a:hover{color:#fff}";
  styleInject(css);

  return Navbar;

})));
